Subject: Re: how many SMTP/Submit clients use CHUNKING and BINARYMIME
From: Alexey Melnikov <[email-masked]>
To: Arnt Gulbrandsen <[email-masked]>
Cc: [email-masked]
Date: Wed, 15 Apr 2009 08:48:30 +0100
List-Id: <ietf-smtp.imc.org>

Arnt Gulbrandsen wrote:

> Alexey Melnikov answers Ned Freed:
>
>>> Indeed. I don't believe I've ever seen a publicly available client 
>>> capable of it either.
>>
>> Polymer can do that, even though it is hardly a mainstream client.
>> I am trying to remember (from the Lemonade interop event) if there 
>> was one more client.
>
> There wasn't.
>
> I've (once) seen server log entries that showed either BURL/CHUNKING 
> or IMAP CATENATE in the wild, can't remember which. No idea what client.
>
> One swallow does not a summer make.

I am not arguing for advancement to Draft Standard yet ;-).

Date: Wed, 15 Apr 2009 09:38:09 +0200
From: Arnt Gulbrandsen <[email-masked]>
To: [email-masked]
Subject: Re: how many SMTP/Submit clients use CHUNKING and BINARYMIME
Cc: Alexey Melnikov <[email-masked]>, [email-masked], Sabahattin Gucukoglu <[email-masked]>
Sender: [email-masked]

Alexey Melnikov answers Ned Freed:
>> Indeed. I don't believe I've ever seen a publicly available client 
>> capable of it either.
>
> Polymer can do that, even though it is hardly a mainstream client.
> I am trying to remember (from the Lemonade interop event) if there was 
> one more client.

There wasn't.

I've (once) seen server log entries that showed either BURL/CHUNKING or 
IMAP CATENATE in the wild, can't remember which. No idea what client.

One swallow does not a summer make.

Arnt

Date: Wed, 15 Apr 2009 06:11:28 +0100
From: Alexey Melnikov <[email-masked]>
To: [email-masked]
CC: Sabahattin Gucukoglu <[email-masked]>, [email-masked]
Subject: Re: how many SMTP/Submit clients  use CHUNKING and BINARYMIME
Sender: [email-masked]

[email-masked] wrote:

>> On 3 Apr 2009, at 20:24, Tony Hansen wrote:
>> > Are there any Mail User Agents that use BINARYMIME (and CHUNKING, of
>> > course) to submit messages, if the submission server supports
>> > BINARYMIME+CHUNKING? Or do all the MUAs just encode their attachments
>> > using base64/quoted-printable and not bother checking to see if they
>> > need to?
>
>> Even the clients from vendors who servers support CHUNKING don't seem
>> to know how to construct MIME sections with CTE of Binary.
>
> Indeed. I don't believe I've ever seen a publicly available client 
> capable of
> it either.

Polymer can do that, even though it is hardly a mainstream client.
I am trying to remember (from the Lemonade interop event) if there was 
one more client.

> All the binary messages I have are ones I've constructed myself
> using a seriously hacked up client.

Date: Tue, 14 Apr 2009 14:43:32 -0700 (PDT)
From: [email-masked]
Subject: Re: how many SMTP/Submit clients  use CHUNKING and BINARYMIME
To: Sabahattin Gucukoglu <[email-masked]>
Cc: [email-masked]
Sender: [email-masked]

> On 3 Apr 2009, at 20:24, Tony Hansen wrote:
> > Are there any Mail User Agents that use BINARYMIME (and CHUNKING, of
> > course) to submit messages, if the submission server supports
> > BINARYMIME+CHUNKING? Or do all the MUAs just encode their attachments
> > using base64/quoted-printable and not bother checking to see if they
> > need to?

> Even the clients from vendors who servers support CHUNKING don't seem
> to know how to construct MIME sections with CTE of Binary.

Indeed. I don't believe I've ever seen a publicly available client capable of
it either. All the binary messages I have are ones I've constructed myself
using a seriously hacked up client.

FWIW, we have had some support in place for binary for a long, long time, but
I've never been willing to enable it. We had quite enough trouble with CHUNKING
and various firewalls, thank you very much.

> Sad, really.  There's no reason why SMTP can't be a perfectly usable
> asynchronous file transfer service, and that'll be all the more
> essential when we're all using IPv6 and do it for ourselves.  (Or
> perhaps the coffee is a little too strong again.)

Binary isn't required for an asynchronous file transfer service, it merely
makes it more efficient. And most of the benefits of binary would be provided
by a more efficient encoding that stays within the line limits.

> On a related note, Pegasus Mail refuses to adapt to the awful reality
> that everybody else is willing to handle arbitrary line lengths.
> Shall we go around making it mandatory?

You're quite wrong about that. We don't allow arbitrary line lengths in our
software. In fact even though we allow longer lines internally we enforce the
RFC-stated limits pretty carefully and provide a number of options for dealing
with incompliant material, NOT including sending it on unchanged. (I reject
categorically and absolutely the "I can send along anything I got" theory of
operation.) I would object in the strongest terms to any attempt to alter this
in the standards at this late date.

Now, if Pegasus Mail falls over when presented with overly long lines or
something similar, that's a robustness issue that needs to be fixed. But it is
in no way a standards issue - it is axiomatic that no input, no matter how
malformed, should be able to kill a piece of server software.

				Ned

From: Sabahattin Gucukoglu <[email-masked]>
To: [email-masked]
Subject: Re: how many SMTP/Submit clients  use CHUNKING and BINARYMIME
Date: Tue, 14 Apr 2009 20:23:52 +0100
Sender: [email-masked]

On 3 Apr 2009, at 20:24, Tony Hansen wrote:
> Are there any Mail User Agents that use BINARYMIME (and CHUNKING, of
> course) to submit messages, if the submission server supports
> BINARYMIME+CHUNKING? Or do all the MUAs just encode their attachments
> using base64/quoted-printable and not bother checking to see if they
> need to?

Even the clients from vendors who servers support CHUNKING don't seem  
to know how to construct MIME sections with CTE of Binary.

Sad, really.  There's no reason why SMTP can't be a perfectly usable  
asynchronous file transfer service, and that'll be all the more  
essential when we're all using IPv6 and do it for ourselves.  (Or  
perhaps the coffee is a little too strong again.)

On a related note, Pegasus Mail refuses to adapt to the awful reality  
that everybody else is willing to handle arbitrary line lengths.   
Shall we go around making it mandatory?

Cheers,
Sabahattin

Date: Fri, 03 Apr 2009 15:24:52 -0400
From: Tony Hansen <[email-masked]>
To: [email-masked]
Subject: how many SMTP/Submit clients  use CHUNKING and BINARYMIME
Sender: [email-masked]

Are there any Mail User Agents that use BINARYMIME (and CHUNKING, of
course) to submit messages, if the submission server supports
BINARYMIME+CHUNKING? Or do all the MUAs just encode their attachments
using base64/quoted-printable and not bother checking to see if they
need to?

	Tony